%global momorel 1

%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

%define libvncver 0.7.1

Summary: Xen is a virtual machine monitor
Name:    xen
Version: 3.0.2
Release: %{momorel}m
Group:   Development/Libraries
License: GPL
URL:     http://www.cl.cam.ac.uk/Research/SRG/netos/xen/index.html
Source0: xen-unstable-10278.tar.bz2
Source1: http://download.sf.net/libvncserver/LibVNCServer-%{libvncver}.tar.gz
Source2: xenguest-install.py
Source3: xen-udev.rules
Patch1: xen-initscript.patch
Patch6: xen-network-iptables-bridge.patch
Patch8: xen-vmxballoon-hack.patch
Patch11: xen-3.0.1-cloexec.patch
Patch12: xen-3.0.1-tempdir.patch

# Patches to modify the default config of xend
Patch100: xen-config-dom0-minmem.patch
Patch101: xen-config-allow-http.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: transfig libidn-devel zlib-devel texi2html SDL-devel curl-devel
BuildRequires: libX11-devel python-devel ghostscript tetex-latex 
BuildRequires: ncurses-devel
# for the VMX "bios" 
BuildRequires: dev86
# for the docs 
BuildRequires: perl 
# so that the makefile knows to install udev rules
BuildRequires: udev 
# so that x86_64 builds pick up glibc32 correctly
BuildRequires: /usr/include/gnu/stubs-32.h
Requires: bridge-utils
Requires: python-abi = %(%{__python} -c "import sys ; print sys.version[:3]")
Requires: udev >= 059
Requires: libvirt-python
Prereq: chkconfig
ExclusiveArch: %{ix86} x86_64

%description
This package contains the Xen hypervisor and Xen tools, needed to
run virtual machines on x86 systems, together with the kernel-xen*
packages.  Information on how to use Xen can be found at the Xen
project pages.

Virtualisation can be used to run multiple versions or multiple
Linux distributions on one system, or to test untrusted applications
in a sandboxed environment.  Note that the Xen technology is still
in development, and this RPM has received extremely little testing.
Don't be surprised if this RPM eats your data, drinks your coffee
or makes fun of you in front of your friends.

%prep
%setup -q -n xen-unstable.hg -a 1
%patch1 -p1 -b .init
%patch6 -p1
%patch8 -p1
#patch11 -p1 -b .cloexec
%patch12 -p1 -b .tempdir

# config patches
%patch100 -p1
%patch101 -p1

cp %{SOURCE2} .

%build
pushd LibVNCServer-%{libvncver}
%configure
make
vncdir=`pwd`
popd

sed -i -e "s;libvncserver-config;${vncdir}/libvncserver-config;" tools/ioemu/configure
CFLAGS="$RPM_OPT_FLAGS" %{__make} XEN_PYTHON_NATIVE_INSTALL=1 DESTDIR=%{buildroot} tools docs 

%install
rm -rf %{buildroot}
make XEN_PYTHON_NATIVE_INSTALL=1 DESTDIR=%{buildroot} prefix=/usr install-tools install-docs
mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}/xend-db/domain
mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}/xend-db/vnet
mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}/xend-db/migrate
mkdir -p %{buildroot}%{_localstatedir}/lib/xenstored
mkdir -p %{buildroot}%{_localstatedir}/run/xenstored
rm -rf %{buildroot}%{_datadir}/doc/qemu

rm -rf %{buildroot}%{_sysconfdir}/hotplug

# xs.h and xs_lib.h requires xen/io/xs_wire.h
mkdir -p %{buildroot}%{_includedir}/xen/io
install -m 644 tools/libxc/xen/xen.h %{buildroot}%{_includedir}/xen
install -m 644 tools/libxc/xen/dom0_ops.h %{buildroot}%{_includedir}/xen
install -m 644 tools/libxc/xen/version.h %{buildroot}%{_includedir}/xen
install -m 644 tools/libxc/xen/event_channel.h %{buildroot}%{_includedir}/xen
install -m 644 tools/libxc/xen/sched.h %{buildroot}%{_includedir}/xen
install -m 644 tools/libxc/xen/sched_ctl.h %{buildroot}%{_includedir}/xen
install -m 644 tools/libxc/xen/memory.h %{buildroot}%{_includedir}/xen
install -m 644 tools/libxc/xen/acm.h %{buildroot}%{_includedir}/xen
install -m 644 tools/libxc/xen/arch-x86_32.h %{buildroot}%{_includedir}/xen
install -m 644 tools/libxc/xen/arch-x86_64.h %{buildroot}%{_includedir}/xen
install -m 644 tools/libxc/xen/arch-ia64.h %{buildroot}%{_includedir}/xen
install -m 644 xen/include/public/io/xs_wire.h %{buildroot}%{_includedir}/xen/io
install -m 644 xen/include/public/xen-compat.h %{buildroot}%{_includedir}/xen

### fixing start-script dir
mkdir -p %{buildroot}/etc/rc.d
mv -f %{buildroot}/etc/init.d %{buildroot}/etc/rc.d/

mv -f %{buildroot}/etc/udev/xen-backend.rules %{buildroot}/etc/udev/rules.d/
install -m 0644 %{SOURCE3} %{buildroot}/etc/udev/rules.d/60-xen.rules

# Hand-install the local xenguest-install.py addon
install -m 755 xenguest-install.py %{buildroot}%{_sbindir}

# silly doc dir fun
rm -fr %{buildroot}/%{_datadir}/doc/xen/

# create dirs in /var/run so that selinux contexts are right (#195952)
mkdir -p %{buildroot}/var/run/xend

%post
/sbin/chkconfig --add xend
/sbin/chkconfig --add xendomains

%preun
if [ $1 = 0 ]; then
  /sbin/chkconfig --del xend
  /sbin/chkconfig --del xendomains
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc COPYING README
%doc docs/pdf/
%doc docs/misc/
%{_sbindir}/*
%{_bindir}/*
%{_includedir}/*.h
%{_includedir}/xen/*.h
%{_includedir}/xen/io/*.h
%{_includedir}/xen/linux/*.h
%{python_sitearch}/%{name}
%{python_sitearch}/grub
%{_libdir}/%{name}
%{_libdir}/lib*
%{_mandir}/man?/*.?.*
%dir /usr/lib/xen
%dir /usr/lib/xen/boot
/usr/lib/xen/boot/hvmloader
%dir %{_datadir}/%{name}/qemu
%{_datadir}/%{name}/qemu/keymaps/*
%dir %{_localstatedir}/lib/%{name}
%{_localstatedir}/lib/%{name}/*
%{_sysconfdir}/rc.d/init.d/*
%{_sysconfdir}/udev/rules.d/*
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/*
%config(noreplace) %{_sysconfdir}/sysconfig/xendomains
%dir %{_localstatedir}/lib/xenstored
%dir %{_localstatedir}/run/xenstored
%dir %{_localstatedir}/run/xend

%changelog
* Fri Jul  7 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (3.0.2-1m)
- import from fc-devel

* Sun Jan  8 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (3.0-0.20051206.1m)
- sync with fc-devel

* Sat Oct 30 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (2-20051030m)
- rebuild against python-2.4.2

* Wed Mar 23 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (2-20050308m)
- import from FC

* Wed Mar  9 2005 Rik van Riel <riel@redhat.com> 2-20050308
- upgrade to last night's snapshot
- new compile fix patch

* Sun Mar  6 2005 Rik van Riel <riel@redhat.com> 2-20050305
- the gcc4 compile patches are now upstream
- upgrade to last night's snapshot, drop patches locally

* Fri Mar  4 2005 Rik van Riel <riel@redhat.com> 2-20050303
- finally got everything to compile with gcc4 -Wall -Werror

* Thu Mar  3 2005 Rik van Riel <riel@redhat.com> 2-20050303
- upgrade to last night's Xen-unstable snapshot
- drop printf warnings patch, which is upstream now

* Wed Feb 23 2005 Rik van Riel <riel@redhat.com> 2-20050222
- upgraded to last night's Xen snapshot
- compile warning fixes are now upstream, drop patch

* Sat Feb 19 2005 Rik van Riel <riel@redhat.com> 2-20050219
- fix more compile warnings
- fix the fwrite return check

* Fri Feb 18 2005 Rik van Riel <riel@redhat.com> 2-20050218
- upgrade to last night's Xen snapshot
- a kernel upgrade is needed to run this Xen, the hypervisor
  interface changed slightly
- comment out unused debugging function in plan9 domain builder
  that was giving compile errors with -Werror

* Tue Feb  8 2005 Rik van Riel <riel@redhat.com> 2-20050207
- upgrade to last night's Xen snapshot

* Tue Feb  1 2005 Rik van Riel <riel@redhat.com> 2-20050201.1
- move everything to /var/lib/xen

* Tue Feb  1 2005 Rik van Riel <riel@redhat.com> 2-20050201
- upgrade to new upstream Xen snapshot

* Tue Jan 25 2005 Jeremy Katz <katzj@redhat.com>
- add buildreqs on python-devel and xorg-x11-devel (strange AT nsk.no-ip.org)

* Mon Jan 24 2005 Rik van Riel <riel@redhat.com> - 2-20050124
- fix /etc/xen/scripts/network to not break with ipv6 (also sent upstream)

* Fri Jan 14 2005 Jeremy Katz <katzj@redhat.com> - 2-20050114
- update to new snap
- python-twisted is its own package now
- files are in /usr/lib/python now as well, ugh.

* Tue Jan 11 2005 Rik van Riel <riel@redhat.com>
- add segment fixup patch from xen tree
- fix %files list for python-twisted

* Mon Jan 10 2005 Rik van Riel <riel@redhat.com>
- grab newer snapshot, that does start up
- add /var/xen/xend-db/{domain,vnet} to %files section

* Thu Jan  6 2005 Rik van Riel <riel@redhat.com>
- upgrade to new snapshot of xen-unstable

* Mon Dec 13 2004 Rik van Riel <riel@redhat.com>
- build python-twisted as a subpackage
- update to latest upstream Xen snapshot

* Sun Dec  5 2004 Rik van Riel <riel@redhat.com>
- grab new Xen tarball (with wednesday's patch already included)
- transfig is a buildrequire, add it to the spec file

* Wed Dec  1 2004 Rik van Riel <riel@redhat.com>
- fix up Che's spec file a little bit
- create patch to build just Xen, not the kernels

* Wed Dec 01 2004 Che
- initial rpm release
